package za.co.xx.aut;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.soa.esb.client.ServiceInvoker;
import org.jboss.soa.esb.message.Message;
import org.jboss.soa.esb.message.format.MessageFactory;
import org.jboss.soa.esb.message.format.MessageType;

public class ESBInvoker extends HttpServlet {

	private Log log = LogFactory.getLog(getClass());

	protected void doGet(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		doPost(request, response);
	}

	protected void doPost(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		PrintWriter out = response.getWriter();
		log.info("Servlet service hit.  About to invoke EntryPointService.");
		try {
			// Create the delivery adapter for the target service (you'd
			// normally cache this !!)...
			ServiceInvoker deliveryAdapter = new org.jboss.soa.esb.client.ServiceInvoker(
					"AutActions", "EntryPointAction");

			// Create and populate the request message...
			Message requestMessage = MessageFactory.getInstance().getMessage(
					MessageType.JBOSS_XML);
			String action = request.getParameter("action");
			String message = request.getParameter("message");
			if(message == null) {
				message = "";
				action = "read";
			}
			if(action == null)
				action = "read";
			requestMessage.getProperties().setProperty("action", action);
			requestMessage.getBody().add("testMessage", message);

			// Deliver the request message
			deliveryAdapter.deliverSync(requestMessage, 5000);
			log.info("Message delivered.");

			out.write("ESB service invoked sucessfully!");

		} catch (Exception ex) {
			out.write("Error when invoking ESB: " + ex.getMessage());
			log.error("Error when invoking ESB: " + ex.getMessage());
			throw new RuntimeException(ex.getMessage(), ex);
		}

	}

}
