package za.co.xx.aut.actions.entrypoint;

import org.jboss.soa.esb.ConfigurationException;
import org.jboss.soa.esb.actions.AbstractSpringAction;
import org.jboss.soa.esb.actions.ActionLifecycleException;
import org.jboss.soa.esb.actions.ActionProcessingException;
import org.jboss.soa.esb.helpers.ConfigTree;
import org.jboss.soa.esb.message.Message;
import org.springframework.beans.BeansException;

import za.co.xx.aut.AutService;

public class AutAction extends AbstractSpringAction {

	@SuppressWarnings("deprecation")
	public AutAction(final ConfigTree config) throws ConfigurationException {
		configTree = config; 
	}

	public Message process(final Message message)
			throws ActionProcessingException, BeansException, ActionLifecycleException {
		
		AutService service =  (AutService)getBeanFactory().getBean("autService"); 
		if(service == null){
			System.out.println("Service is NULL!");
			throw new IllegalStateException("Spring context invalid!");
		}
		if(message.getProperties().getProperty("action").equals("error")){
			throw new IllegalStateException("Forced Failure");
		}
		if (message.getProperties().getProperty("action").equals("read")) {
			service.read();
		} else {
			service.write((String) message.getBody().get("testMessage"));
		}
		return message;
	}

}
